#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cstring>
using namespace std;

struct node
{
	int to,next;
}e[1000010];

int n,q;
int tot,hd[1000010];
int f[500010][21],dep[500010],lcc[5010][5010];
int l[500010],r[500010],k[500010];

void add(int x,int y)
{
	e[++tot]=(node){y,hd[x]};
	hd[x]=tot;
}

void dfs(int x,int fx)
{
	dep[x]=dep[fx]+1;
	f[x][0]=fx;
	for(int j=1;j<=20;j++)
	{
		f[x][j]=f[f[x][j-1]][j-1];
	}
	for(int i=hd[x];i;i=e[i].next)
	{
		int v=e[i].to;
		if(v==fx) continue;
		dfs(v,x);
	}
}

int lca(int x,int y)
{
	if(dep[y]>dep[x]) swap(x,y);
	for(int i=20;i>=0;i--)
	{
		if(dep[f[x][i]]>=dep[y])
		{
			x=f[x][i];
		}
	}
	if(x==y) return x;
	for(int i=20;i>=0;i--)
	{
		if(f[x][i]!=f[y][i])
		{
			x=f[x][i];
			y=f[y][i];
		}
	}
	return f[x][0];
}

int main()
{
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%d",&n);
	for(int i=1;i<=n-1;i++)
	{
		int u,v;
		scanf("%d%d",&u,&v);
		add(u,v);
		add(v,u);
	}
	dfs(1,0);
	scanf("%d",&q);
	for(int i=1;i<=q;i++)
	{
		scanf("%d%d%d",&l[i],&r[i],&k[i]);
	}
	for(int i=1;i<=n-1;i++)
	{
		for(int j=i+1;j<=n;j++)
		{
			int pre=i;
			for(int t=i+1;t<=j;t++)
			{
				pre=lca(pre,t);
			}
			lcc[i][j]=pre;
		}
	}
	for(int i=1;i<=n;i++)
	{
		lcc[i][i]=i;
	}
	dep[0]=0;
	for(int i=1;i<=q;i++)
	{
		int ans=0;
		for(int j=l[i];j+k[i]-1<=r[i];j++)
		{
			ans=max(ans,dep[lcc[j][j+k[i]-1]]);
		}
		cout<<ans<<endl;
	}
	return 0;
}
/*
6
5 6
6 1
6 2
2 3
2 4
3
2 5 2
1 4 1
1 6 3

*/
